> ## Documentation Index
> Fetch the complete documentation index at: https://docs.merchantspring.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a customer lifetime value report

> Create a "customer lifetime value" report. The generated report CSV contains the columns defined in the `CustomerLifetimeValueReportColumns` schema including cohort metrics such as LTV, CAC, and repeat purchase frequency. Use the /reports/status/{reportId} endpoint to check report status and obtain the download URL.



## OpenAPI

````yaml /api-reference/openapi.json post /reports/create/customerLifetimeValue
openapi: 3.0.1
info:
  title: MerchantSpring Public API
  version: 1.0.0
servers:
  - url: https://mm-api.merchantspring.io
    description: Production
  - url: https://mm-api-staging.merchantspring.io
    description: Staging
security: []
tags:
  - name: channel
    x-group: Channel
  - name: content-change
    x-group: Content Change
  - name: custom-group
    x-group: Custom Group
  - name: order
    x-group: Order
  - name: report
    x-group: Report
  - name: tag
    x-group: Tag
  - name: profitability
    x-group: Profitability
paths:
  /reports/create/customerLifetimeValue:
    post:
      tags:
        - report
      summary: Create a customer lifetime value report
      description: >-
        Create a "customer lifetime value" report. The generated report CSV
        contains the columns defined in the `CustomerLifetimeValueReportColumns`
        schema including cohort metrics such as LTV, CAC, and repeat purchase
        frequency. Use the /reports/status/{reportId} endpoint to check report
        status and obtain the download URL.
      operationId: createCustomerLifetimeValueReport
      requestBody:
        description: Report criteria
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateCustomerLifetimeValueReportRequest'
        required: true
      responses:
        '200':
          description: Successful operation
          headers:
            Access-Control-Allow-Origin:
              schema:
                type: string
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreateReportResponse'
            text/csv:
              schema:
                $ref: '#/components/schemas/CustomerLifetimeValueReportColumns'
        '400':
          description: Invalid input
          content: {}
      security:
        - api_key: []
components:
  schemas:
    CreateCustomerLifetimeValueReportRequest:
      type: object
      properties:
        channelId:
          type: string
        merchantId:
          type: string
        reportOptions:
          $ref: '#/components/schemas/CreateCustomerLifetimeValueReportOptions'
    CreateReportResponse:
      type: object
      properties:
        reportId:
          type: string
        reportType:
          type: string
        status:
          type: string
    CustomerLifetimeValueReportColumns:
      type: object
      description: Columns present in the downloadable Customer Lifetime Value report CSV.
      properties:
        startTime:
          type: string
          description: Start of the cohort time period
        totalRevenue:
          type: number
          description: Total revenue from all customers
        repeatCustomersRevenue:
          type: number
          description: Revenue from repeat customers
        repeatRevenuePercentage:
          type: number
          description: Percentage of revenue from repeat customers
        totalCustomers:
          type: number
          description: Total number of customers
        repeatCustomers:
          type: number
          description: Number of repeat customers
        repeatCustomersPercentage:
          type: number
          description: Percentage of customers who are repeat buyers
        averageLTV:
          type: number
          description: Average lifetime value per customer
        averageRepeatLTV:
          type: number
          description: Average lifetime value per repeat customer
        adSpend:
          type: number
          description: Advertising spend in the period
        cac:
          type: number
          description: Customer Acquisition Cost
        ltvCacRatio:
          type: number
          description: Ratio of lifetime value to customer acquisition cost
        repeatPurchases:
          type: number
          description: Number of repeat purchases
        purchaseFrequency:
          type: number
          description: Average purchase frequency
        currency:
          type: string
          description: Currency code (e.g. USD, GBP)
    CreateCustomerLifetimeValueReportOptions:
      allOf:
        - $ref: '#/components/schemas/CommonReportOptions'
        - type: object
          properties:
            fromDate:
              type: integer
              description: >-
                Unix epoch time (seconds) representing the start of the
                reporting period
            toDate:
              type: integer
              description: >-
                Unix epoch time (seconds) representing the end of the reporting
                period
            priorFromDate:
              type: number
              description: >-
                Unix epoch time (seconds) representing the start of the
                comparison period
            priorToDate:
              type: number
              description: >-
                Unix epoch time (seconds) representing the end of the comparison
                period
            timezone:
              type: string
              description: >-
                The timezone string you wish to see the report in (e.g.
                'America/Los_Angeles') see
                https://en.wikipedia.org/wiki/List_of_tz_database_time_zones
    CommonReportOptions:
      type: object
      properties:
        fromDate:
          type: number
          description: >-
            Unix epoch time (seconds) representing the start of the reporting
            period
        toDate:
          type: number
          description: >-
            Unix epoch time (seconds) representing the end of the reporting
            period
        priorFromDate:
          type: number
          description: >-
            Unix epoch time (seconds) representing the start of the comparison
            period
        priorToDate:
          type: number
          description: >-
            Unix epoch time (seconds) representing the end of the comparison
            period
        timezone:
          type: string
          description: >-
            The timezone string you wish to see the report in (e.g.
            'America/Los_Angeles') see
            https://en.wikipedia.org/wiki/List_of_tz_database_time_zones
  securitySchemes:
    api_key:
      type: apiKey
      name: x-api-key
      in: header

````